/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.43 from the
 * contents of Data-TxnBuffer.xs. Do not edit this file, edit Data-TxnBuffer.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "src/Data-TxnBuffer.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#define NEED_sv_2pvbyte
#include "ppport.h"

#define BUFFER_MAX_REUSE_SIZE  (4 * 1024)
#define BUFFER_PIECE_SIZE 64

#include <assert.h>
#include <stdlib.h>
#include <string.h>

#include <arpa/inet.h>

#if !defined(__LITTLE_ENDIAN__) && !defined(__BIG_ENDIAN__)
#if __BYTE_ORDER == __LITTLE_ENDIAN
#define __LITTLE_ENDIAN__
#elif __BYTE_ORDER == __BIG_ENDIAN
#define __BIG_ENDIAN__
#endif
#endif

typedef struct {
    char* ptr;
    size_t used;
    size_t size;
} buffer;

static buffer* buffer_init(void);
static buffer* buffer_init_buffer(buffer* b);
static buffer* buffer_init_string(const char* str);
static void buffer_free(buffer* b);
static void buffer_reset(buffer* b);

static int buffer_prepare_copy(buffer* b, size_t size);
static int buffer_prepare_append(buffer* b, size_t size);

static int buffer_copy_string(buffer* b, const char* s);
static int buffer_copy_string_len(buffer* b, const char* s, size_t s_len);
static int buffer_copy_string_buffer(buffer* b, const buffer* src);

static int buffer_append_string(buffer* b, const char* s);
static int buffer_append_string_len(buffer* b, const char* s, size_t s_len);
static int buffer_append_string_buffer(buffer* b, const buffer* src);

static int buffer_spin(buffer* b, size_t len);

static buffer* buffer_init(void) {
    buffer* b;

    b = calloc(1, sizeof(buffer));
    assert(b);

    return b;
}

static buffer* buffer_init_buffer(buffer* src) {
    buffer* b = buffer_init();
    buffer_copy_string_buffer(b, src);
    return b;
}

static void buffer_free(buffer* b) {
    if (!b) return;

    free(b->ptr);
    free(b);
}

static void buffer_reset(buffer* b) {
    if (!b) return;

    if (b->size > BUFFER_MAX_REUSE_SIZE) {
        free(b->ptr);
        b->ptr = NULL;
        b->size = 0;
    }
    else if (b->size) {
        b->ptr[0] = '\0';
    }

    b->used = 0;
}

static int buffer_prepare_copy(buffer* b, size_t size) {
    if (!b) return -1;

    if ((0 == b->size) || (size > b->size)) {
        if (b->size) free(b->ptr);

        b->size = size;
        b->size += BUFFER_PIECE_SIZE - (b->size % BUFFER_PIECE_SIZE);

        b->ptr = malloc(b->size);
        assert(b->ptr);
    }

    b->used = 0;
    return 0;
}

static int buffer_prepare_append(buffer* b, size_t size) {
    if (!b) return -1;

    if (0 == b->size) {
        b->size = size;
        b->size += BUFFER_PIECE_SIZE - (b->size % BUFFER_PIECE_SIZE);

        b->ptr = malloc(b->size);
        assert(b->ptr);
        b->used = 0;
    }
    else if (b->used + size > b->size) {
        b->size += size;
        b->size += BUFFER_PIECE_SIZE - (b->size % BUFFER_PIECE_SIZE);

        b->ptr = realloc(b->ptr, b->size);
        assert(b->ptr);
    }
    return 0;
}

static int buffer_copy_string(buffer* b, const char* s) {
    size_t s_len;
    if (!s || !b) return -1;

    s_len = strlen(s) + 1;
    buffer_prepare_append(b, s_len);

    memcpy(b->ptr, s, s_len);
    b->used = s_len;

    return 0;
}

static int buffer_copy_string_len(buffer* b, const char* s, size_t s_len) {
    if (!b || !s) return -1;

    buffer_prepare_copy(b, s_len+1);

    memcpy(b->ptr, s, s_len);
    b->ptr[s_len] = '\0';
    b->used = s_len + 1;

    return 0;
}

static int buffer_copy_string_buffer(buffer* b, const buffer* src) {
    if (!src) return -1;

    if (src->used == 0) {
        buffer_reset(b);
        return 0;
    }
    return buffer_copy_string_len(b, src->ptr, src->used - 1);
}

static int buffer_append_string(buffer* b, const char* s) {
    size_t s_len;

    if (!s || !b) return -1;

    s_len = strlen(s);
    buffer_prepare_append(b, s_len + 1);
    if (0 == b->used) b->used++;

    memcpy(b->ptr + b->used - 1, s, s_len + 1);
    b->used += s_len;

    return 0;
}

static int buffer_append_string_len(buffer* b, const char* s, size_t s_len) {
    if (!s || !b) return -1;
    if (0 == s_len) return 0;

    buffer_prepare_append(b, s_len + 1);
    if (0 == b->used) b->used++;

    memcpy(b->ptr + b->used - 1, s, s_len);
    b->used += s_len;
    b->ptr[b->used - 1] = '\0';

    return 0;
}

static int buffer_append_string_buffer(buffer* b, const buffer* src) {
    if (!src) return -1;
    if (0 == src->used) return 0;

    return buffer_append_string_len(b, src->ptr, src->used - 1);
}

static int buffer_spin(buffer* b, size_t len) {
    if (!b) return -1;
    if (0 == b->used) return 0;

    size_t rest = b->used - len;
    if (rest > 0) {
        memmove(b->ptr, b->ptr + len, rest);
        b->used -= len;
    }
    else {
        buffer_reset(b);
    }

    return 0;
}

static inline void buffer_append_u24(buffer* b, uint32_t n) {
#ifdef __LITTLE_ENDIAN__
    buffer_append_string_len(b, (const char*)&n, 3);
#else
    buffer_append_string_len(b, (const char*)&n + 1, 3);
#endif
}

static inline void buffer_append_n32(buffer* b, uint32_t n) {
#ifdef __LITTLE_ENDIAN__
    n = htonl(n);
#endif
    buffer_append_string_len(b, (const char*)&n, 4);
}

static inline void buffer_append_n24(buffer* b, uint32_t n) {
#ifdef __LITTLE_ENDIAN__
    n = htonl(n);
#endif
    buffer_append_string_len(b, (const char*)&n + 1, 3);
}

static inline void buffer_append_n16(buffer* b, uint16_t n) {
#ifdef __LITTLE_ENDIAN__
    n = htons(n);
#endif
    buffer_append_string_len(b, (const char*)&n, 2);
}

static inline uint32_t buffer_get_u24(buffer* b, int cursor) {
    uint32_t i = 0;
#ifdef __LITTLE_ENDIAN__
    memcpy(&i, b->ptr + cursor, 3);
#else
    memcpy(&i + 1, b->ptr + cursor, 3);
#endif

    return i;
}

static inline int32_t buffer_get_i24(buffer* b, int cursor) {
    int32_t i = 0;
#ifdef __LITTLE_ENDIAN__
    memcpy(&i, b->ptr + cursor, 3);
#else
    memcpy(&i + 1, b->ptr + cursor, 3);
#endif

    if (i & 0x800000) i |= 0xff000000;

    return i;
}

static inline uint32_t buffer_get_n32(buffer* b, int cursor) {
    uint32_t i = *((uint32_t*)(b->ptr + cursor));
#ifdef __LITTLE_ENDIAN__
    i = ntohl(i);
#endif
    return i;
}

static inline uint32_t buffer_get_n24(buffer* b, int cursor) {
    uint32_t i = 0;
    memcpy((uint8_t*)&i + 1, b->ptr + cursor, 3); /* network order */

#ifdef __LITTLE_ENDIAN__
    i = ntohl(i);
#endif
    return i;
}

static inline uint16_t buffer_get_n16(buffer* b, int cursor) {
    uint16_t i = *((uint16_t*)(b->ptr + cursor));
#ifdef __LITTLE_ENDIAN__
    i = ntohs(i);
#endif
    return i;
}

typedef struct {
    int cursor;
    buffer* buffer;
} txn_buffer_t;

#define BUFARGS \
    MAGIC* m; \
    buffer* b; \
    txn_buffer_t* context = NULL;              \
    m = mg_find(SvRV(sv_obj), PERL_MAGIC_ext); \
    if (NULL != m) context = (txn_buffer_t*)m->mg_obj; \
    if (NULL == context) croak("This is not Data::TxnBuffer object\n"); \
    b = context->buffer;

#line 314 "src/Data-TxnBuffer.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 458 "src/Data-TxnBuffer.c"

XS_EUPXS(XS_Data__TxnBuffer_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Data__TxnBuffer_new)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "class, sv_data=NULL");
    {
	SV *	RETVAL;
	char*	class = (char *)SvPV_nolen(ST(0))
;
	SV*	sv_data;

	if (items < 2)
	    sv_data = NULL;
	else {
	    sv_data = ST(1)
;
	}
#line 309 "src/Data-TxnBuffer.xs"
{
    HV* hv;
    SV* sv;
    HV* stash;
    txn_buffer_t* context;
    buffer* b;
    char* data = NULL;
    STRLEN len;

    hv = (HV*)sv_2mortal((SV*)newHV());
    sv = sv_2mortal(newRV_inc((SV*)hv));

    stash = gv_stashpv(class, 0);
    assert(NULL != stash);
    sv_bless(sv, stash);

    b = buffer_init();

    context = malloc(sizeof(txn_buffer_t));
    context->cursor = 0;
    context->buffer = b;

    sv_magic((SV*)hv, NULL, PERL_MAGIC_ext, NULL, 0);
    mg_find((SV*)hv, PERL_MAGIC_ext)->mg_obj = (void*)context;

    if (NULL != sv_data) {
        data = SvPVbyte(sv_data, len);
        assert(NULL != data);
        buffer_append_string_len(b, data, len);
    }

    ST(0) = sv;
}
#line 512 "src/Data-TxnBuffer.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Data__TxnBuffer_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Data__TxnBuffer_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv_obj");
    {
	SV*	sv_obj = ST(0)
;
#line 346 "src/Data-TxnBuffer.xs"
{
    BUFARGS;
    buffer_free(b);
    free(context);
}
#line 533 "src/Data-TxnBuffer.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Data__TxnBuffer_data); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Data__TxnBuffer_data)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv_obj");
    {
	SV *	RETVAL;
	SV*	sv_obj = ST(0)
;
#line 355 "src/Data-TxnBuffer.xs"
{
    SV* sv;
    BUFARGS;

    sv = sv_2mortal(newSV(0));
    if (b->used > 0) {
        sv_setpvn(sv, b->ptr, b->used - 1);
    }
    else {
        sv_setpvn(sv, "", 0);
    }

    ST(0) = sv;
}
#line 564 "src/Data-TxnBuffer.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Data__TxnBuffer_cursor); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Data__TxnBuffer_cursor)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv_obj");
    {
	int	RETVAL;
	dXSTARG;
	SV*	sv_obj = ST(0)
;
#line 373 "src/Data-TxnBuffer.xs"
{
    BUFARGS;
    RETVAL = context->cursor;
}
#line 586 "src/Data-TxnBuffer.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Data__TxnBuffer_spin); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Data__TxnBuffer_spin)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv_obj");
    {
	SV *	RETVAL;
	SV*	sv_obj = ST(0)
;
#line 383 "src/Data-TxnBuffer.xs"
{
    SV* sv;
    int r;
    unsigned char* data;
    BUFARGS;

    sv = sv_2mortal(newSV(0));
    if (context->cursor > 0) {
        sv_setpvn(sv, b->ptr, context->cursor);
        buffer_spin(b, context->cursor);
        context->cursor = 0;
    }
    else {
        sv_setpvn(sv, "", 0);
    }

    ST(0) = sv;
}
#line 622 "src/Data-TxnBuffer.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Data__TxnBuffer_reset); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Data__TxnBuffer_reset)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv_obj");
    {
	SV*	sv_obj = ST(0)
;
#line 405 "src/Data-TxnBuffer.xs"
{
    BUFARGS;
    context->cursor = 0;
}
#line 642 "src/Data-TxnBuffer.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Data__TxnBuffer_clear); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Data__TxnBuffer_clear)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv_obj");
    {
	SV*	sv_obj = ST(0)
;
#line 413 "src/Data-TxnBuffer.xs"
{
    BUFARGS;
    context->cursor = 0;
    buffer_reset(b);
}
#line 663 "src/Data-TxnBuffer.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Data__TxnBuffer_length); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Data__TxnBuffer_length)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv_obj");
    {
	int	RETVAL;
	dXSTARG;
	SV*	sv_obj = ST(0)
;
#line 422 "src/Data-TxnBuffer.xs"
{
    BUFARGS;
    RETVAL = b->used > 0 ? b->used - 1 : 0;
}
#line 685 "src/Data-TxnBuffer.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Data__TxnBuffer_write); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Data__TxnBuffer_write)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "sv_obj, sv_buf");
    {
	SV*	sv_obj = ST(0)
;
	SV*	sv_buf = ST(1)
;
#line 432 "src/Data-TxnBuffer.xs"
{
    char* buf = NULL;
    STRLEN len;
    BUFARGS;

    buf = SvPVbyte(sv_buf, len);
    assert(NULL != buf);

    buffer_append_string_len(b, buf, len);
}
#line 714 "src/Data-TxnBuffer.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Data__TxnBuffer_read); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Data__TxnBuffer_read)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "sv_obj, len");
    {
	SV *	RETVAL;
	SV*	sv_obj = ST(0)
;
	int	len = (int)SvIV(ST(1))
;
#line 446 "src/Data-TxnBuffer.xs"
{
    SV* sv;
    BUFARGS;

    if (len <= 0) {
        croak("positive value is required for read. got %d\n", len);
    }
    if (context->cursor + len > b->used) {
        croak("No enough data in buffer for read\n");
    }

    sv = sv_2mortal(newSV(0));
    sv_setpvn(sv, context->buffer->ptr + context->cursor, len);
    context->cursor += len;

    ST(0) = sv;
}
#line 750 "src/Data-TxnBuffer.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Data__TxnBuffer_write_u32); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Data__TxnBuffer_write_u32)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 2)
       croak_xs_usage(cv,  "sv_obj, n");
    {
	SV*	sv_obj = ST(0)
;
	U32	n = (unsigned long)SvUV(ST(1))
;
#line 470 "src/Data-TxnBuffer.xs"
{
    BUFARGS;
    buffer_append_string_len(b, (const char*)&n, 4);
}
#line 773 "src/Data-TxnBuffer.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Data__TxnBuffer_read_u32); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Data__TxnBuffer_read_u32)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv_obj");
    {
	U32	RETVAL;
	dXSTARG;
	SV*	sv_obj = ST(0)
;
#line 478 "src/Data-TxnBuffer.xs"
{
    BUFARGS;
    if (context->cursor + 4 >= b->used) {
        croak("No enough data in buffer for read\n");
    }

    U32 n = *((U32*)(context->buffer->ptr + context->cursor));
    context->cursor += 4;

    RETVAL = n;
}
#line 802 "src/Data-TxnBuffer.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Data__TxnBuffer_read_i32); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Data__TxnBuffer_read_i32)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv_obj");
    {
	I32	RETVAL;
	dXSTARG;
	SV*	sv_obj = ST(0)
;
#line 495 "src/Data-TxnBuffer.xs"
{
    BUFARGS;
    if (context->cursor + 4 >= b->used) {
        croak("No enough data in buffer for read\n");
    }

    I32 n = *((I32*)(context->buffer->ptr + context->cursor));
    context->cursor += 4;

    RETVAL = n;
}
#line 832 "src/Data-TxnBuffer.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Data__TxnBuffer_write_u24); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Data__TxnBuffer_write_u24)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 2)
       croak_xs_usage(cv,  "sv_obj, n");
    {
	SV*	sv_obj = ST(0)
;
	U32	n = (unsigned long)SvUV(ST(1))
;
#line 515 "src/Data-TxnBuffer.xs"
{
    BUFARGS;
    buffer_append_u24(b, (uint32_t)n);
}
#line 856 "src/Data-TxnBuffer.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Data__TxnBuffer_read_u24); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Data__TxnBuffer_read_u24)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv_obj");
    {
	U32	RETVAL;
	dXSTARG;
	SV*	sv_obj = ST(0)
;
#line 523 "src/Data-TxnBuffer.xs"
{
    BUFARGS;
    if (context->cursor + 3 >= b->used) {
        croak("No enough data in buffer for read\n");
    }

    U32 n = buffer_get_u24(b, context->cursor);
    context->cursor += 3;

    RETVAL = n;
}
#line 885 "src/Data-TxnBuffer.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Data__TxnBuffer_read_i24); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Data__TxnBuffer_read_i24)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv_obj");
    {
	I32	RETVAL;
	dXSTARG;
	SV*	sv_obj = ST(0)
;
#line 540 "src/Data-TxnBuffer.xs"
{
    BUFARGS;
    if (context->cursor + 3 >= b->used) {
        croak("No enough data in buffer for read\n");
    }

    I32 n = buffer_get_i24(b, context->cursor);
    context->cursor += 3;

    RETVAL = n;
}
#line 915 "src/Data-TxnBuffer.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Data__TxnBuffer_write_u16); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Data__TxnBuffer_write_u16)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 2)
       croak_xs_usage(cv,  "sv_obj, n");
    {
	SV*	sv_obj = ST(0)
;
	U16	n = (unsigned short)SvUV(ST(1))
;
#line 560 "src/Data-TxnBuffer.xs"
{
    BUFARGS;
    buffer_append_string_len(b, (const char*)&n, 2);
}
#line 939 "src/Data-TxnBuffer.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Data__TxnBuffer_read_u16); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Data__TxnBuffer_read_u16)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv_obj");
    {
	U16	RETVAL;
	dXSTARG;
	SV*	sv_obj = ST(0)
;
#line 568 "src/Data-TxnBuffer.xs"
{
    BUFARGS;
    if (context->cursor + 2 >= b->used) {
        croak("No enough data in buffer for read\n");
    }

    U16 n = *((U16*)(context->buffer->ptr + context->cursor));
    context->cursor += 2;

    RETVAL = n;
}
#line 968 "src/Data-TxnBuffer.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Data__TxnBuffer_read_i16); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Data__TxnBuffer_read_i16)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv_obj");
    {
	I16	RETVAL;
	dXSTARG;
	SV*	sv_obj = ST(0)
;
#line 585 "src/Data-TxnBuffer.xs"
{
    BUFARGS;
    if (context->cursor + 2 >= b->used) {
        croak("No enough data in buffer for read\n");
    }

    I16 n = *((I16*)(context->buffer->ptr + context->cursor));
    context->cursor += 2;

    RETVAL = n;
}
#line 998 "src/Data-TxnBuffer.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Data__TxnBuffer_write_u8); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Data__TxnBuffer_write_u8)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 2)
       croak_xs_usage(cv,  "sv_obj, n");
    {
	SV*	sv_obj = ST(0)
;
	U8	n = (U8)SvUV(ST(1))
;
#line 605 "src/Data-TxnBuffer.xs"
{
    BUFARGS;
    buffer_append_string_len(b, (const char*)&n, 1);
}
#line 1022 "src/Data-TxnBuffer.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Data__TxnBuffer_read_u8); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Data__TxnBuffer_read_u8)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv_obj");
    {
	U8	RETVAL;
	dXSTARG;
	SV*	sv_obj = ST(0)
;
#line 613 "src/Data-TxnBuffer.xs"
{
    BUFARGS;
    if (context->cursor + 1 >= b->used) {
        croak("No enough data in buffer for read\n");
    }

    U8 n = *((U8*)(context->buffer->ptr + context->cursor));
    context->cursor += 1;

    RETVAL = n;
}
#line 1051 "src/Data-TxnBuffer.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Data__TxnBuffer_read_i8); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Data__TxnBuffer_read_i8)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv_obj");
    {
	I8	RETVAL;
	dXSTARG;
	SV*	sv_obj = ST(0)
;
#line 630 "src/Data-TxnBuffer.xs"
{
    BUFARGS;
    if (context->cursor + 1 >= b->used) {
        croak("No enough data in buffer for read\n");
    }

    I8 n = *((I8*)(context->buffer->ptr + context->cursor));
    context->cursor += 1;

    RETVAL = n;
}
#line 1081 "src/Data-TxnBuffer.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Data__TxnBuffer_write_n32); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Data__TxnBuffer_write_n32)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "sv_obj, n");
    {
	SV*	sv_obj = ST(0)
;
	U32	n = (unsigned long)SvUV(ST(1))
;
#line 647 "src/Data-TxnBuffer.xs"
{
    BUFARGS;
    buffer_append_n32(b, n);
}
#line 1104 "src/Data-TxnBuffer.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Data__TxnBuffer_read_n32); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Data__TxnBuffer_read_n32)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv_obj");
    {
	U32	RETVAL;
	dXSTARG;
	SV*	sv_obj = ST(0)
;
#line 655 "src/Data-TxnBuffer.xs"
{
    BUFARGS;
    if (context->cursor + 4 >= b->used) {
        croak("No enough data in buffer for read\n");
    }

    U32 n = buffer_get_n32(b, context->cursor);
    context->cursor += 4;

    RETVAL = n;
}
#line 1133 "src/Data-TxnBuffer.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Data__TxnBuffer_write_n24); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Data__TxnBuffer_write_n24)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "sv_obj, n");
    {
	SV*	sv_obj = ST(0)
;
	U32	n = (unsigned long)SvUV(ST(1))
;
#line 672 "src/Data-TxnBuffer.xs"
{
    BUFARGS;
    buffer_append_n24(b, n);
}
#line 1156 "src/Data-TxnBuffer.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Data__TxnBuffer_read_n24); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Data__TxnBuffer_read_n24)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv_obj");
    {
	U32	RETVAL;
	dXSTARG;
	SV*	sv_obj = ST(0)
;
#line 680 "src/Data-TxnBuffer.xs"
{
    BUFARGS;
    if (context->cursor + 3 >= b->used) {
        croak("No enough data in buffer for read\n");
    }

    U32 n = buffer_get_n24(b, context->cursor);
    context->cursor += 3;

    RETVAL = n;
}
#line 1185 "src/Data-TxnBuffer.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Data__TxnBuffer_write_n16); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Data__TxnBuffer_write_n16)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "sv_obj, n");
    {
	SV*	sv_obj = ST(0)
;
	U16	n = (unsigned short)SvUV(ST(1))
;
#line 697 "src/Data-TxnBuffer.xs"
{
    BUFARGS;
    buffer_append_n16(b, n);
}
#line 1208 "src/Data-TxnBuffer.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Data__TxnBuffer_read_n16); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Data__TxnBuffer_read_n16)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv_obj");
    {
	U16	RETVAL;
	dXSTARG;
	SV*	sv_obj = ST(0)
;
#line 705 "src/Data-TxnBuffer.xs"
{
    BUFARGS;
    if (context->cursor + 2 >= b->used) {
        croak("No enough data in buffer for read\n");
    }

    U16 n = buffer_get_n16(b, context->cursor);
    context->cursor += 2;

    RETVAL = n;
}
#line 1237 "src/Data-TxnBuffer.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Data__TxnBuffer_write_float); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Data__TxnBuffer_write_float)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "sv_obj, n");
    {
	SV*	sv_obj = ST(0)
;
	float	n = (float)SvNV(ST(1))
;
#line 722 "src/Data-TxnBuffer.xs"
{
    BUFARGS;
    buffer_append_string_len(b, (const char*)&n, 4);
}
#line 1260 "src/Data-TxnBuffer.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Data__TxnBuffer_read_float); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Data__TxnBuffer_read_float)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv_obj");
    {
	float	RETVAL;
	dXSTARG;
	SV*	sv_obj = ST(0)
;
#line 730 "src/Data-TxnBuffer.xs"
{
    BUFARGS;
    if (context->cursor + 4 >= b->used) {
        croak("No enough data in buffer for read\n");
    }

    float n = *((float*)(b->ptr + context->cursor));
    context->cursor += 4;

    RETVAL = n;
}
#line 1289 "src/Data-TxnBuffer.c"
	XSprePUSH; PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Data__TxnBuffer_write_double); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Data__TxnBuffer_write_double)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "sv_obj, n");
    {
	SV*	sv_obj = ST(0)
;
	double	n = (double)SvNV(ST(1))
;
#line 747 "src/Data-TxnBuffer.xs"
{
    BUFARGS;
    buffer_append_string_len(b, (const char*)&n, 8);
}
#line 1312 "src/Data-TxnBuffer.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Data__TxnBuffer_read_double); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Data__TxnBuffer_read_double)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv_obj");
    {
	double	RETVAL;
	dXSTARG;
	SV*	sv_obj = ST(0)
;
#line 755 "src/Data-TxnBuffer.xs"
{
    BUFARGS;
    if (context->cursor + 8 >= b->used) {
        croak("No enough data in buffer for read\n");
    }

    double n = *((double*)(b->ptr + context->cursor));
    context->cursor += 8;

    RETVAL = n;
}
#line 1341 "src/Data-TxnBuffer.c"
	XSprePUSH; PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Data__TxnBuffer); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Data__TxnBuffer)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Data::TxnBuffer::new", XS_Data__TxnBuffer_new);
        newXS_deffile("Data::TxnBuffer::DESTROY", XS_Data__TxnBuffer_DESTROY);
        newXS_deffile("Data::TxnBuffer::data", XS_Data__TxnBuffer_data);
        newXS_deffile("Data::TxnBuffer::cursor", XS_Data__TxnBuffer_cursor);
        newXS_deffile("Data::TxnBuffer::spin", XS_Data__TxnBuffer_spin);
        newXS_deffile("Data::TxnBuffer::reset", XS_Data__TxnBuffer_reset);
        newXS_deffile("Data::TxnBuffer::clear", XS_Data__TxnBuffer_clear);
        newXS_deffile("Data::TxnBuffer::length", XS_Data__TxnBuffer_length);
        newXS_deffile("Data::TxnBuffer::write", XS_Data__TxnBuffer_write);
        newXS_deffile("Data::TxnBuffer::read", XS_Data__TxnBuffer_read);
        cv = newXS_deffile("Data::TxnBuffer::write_i32", XS_Data__TxnBuffer_write_u32);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("Data::TxnBuffer::write_u32", XS_Data__TxnBuffer_write_u32);
        XSANY.any_i32 = 0;
        newXS_deffile("Data::TxnBuffer::read_u32", XS_Data__TxnBuffer_read_u32);
        newXS_deffile("Data::TxnBuffer::read_i32", XS_Data__TxnBuffer_read_i32);
        cv = newXS_deffile("Data::TxnBuffer::write_i24", XS_Data__TxnBuffer_write_u24);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("Data::TxnBuffer::write_u24", XS_Data__TxnBuffer_write_u24);
        XSANY.any_i32 = 0;
        newXS_deffile("Data::TxnBuffer::read_u24", XS_Data__TxnBuffer_read_u24);
        newXS_deffile("Data::TxnBuffer::read_i24", XS_Data__TxnBuffer_read_i24);
        cv = newXS_deffile("Data::TxnBuffer::write_i16", XS_Data__TxnBuffer_write_u16);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("Data::TxnBuffer::write_u16", XS_Data__TxnBuffer_write_u16);
        XSANY.any_i32 = 0;
        newXS_deffile("Data::TxnBuffer::read_u16", XS_Data__TxnBuffer_read_u16);
        newXS_deffile("Data::TxnBuffer::read_i16", XS_Data__TxnBuffer_read_i16);
        cv = newXS_deffile("Data::TxnBuffer::write_i8", XS_Data__TxnBuffer_write_u8);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("Data::TxnBuffer::write_u8", XS_Data__TxnBuffer_write_u8);
        XSANY.any_i32 = 0;
        newXS_deffile("Data::TxnBuffer::read_u8", XS_Data__TxnBuffer_read_u8);
        newXS_deffile("Data::TxnBuffer::read_i8", XS_Data__TxnBuffer_read_i8);
        newXS_deffile("Data::TxnBuffer::write_n32", XS_Data__TxnBuffer_write_n32);
        newXS_deffile("Data::TxnBuffer::read_n32", XS_Data__TxnBuffer_read_n32);
        newXS_deffile("Data::TxnBuffer::write_n24", XS_Data__TxnBuffer_write_n24);
        newXS_deffile("Data::TxnBuffer::read_n24", XS_Data__TxnBuffer_read_n24);
        newXS_deffile("Data::TxnBuffer::write_n16", XS_Data__TxnBuffer_write_n16);
        newXS_deffile("Data::TxnBuffer::read_n16", XS_Data__TxnBuffer_read_n16);
        newXS_deffile("Data::TxnBuffer::write_float", XS_Data__TxnBuffer_write_float);
        newXS_deffile("Data::TxnBuffer::read_float", XS_Data__TxnBuffer_read_float);
        newXS_deffile("Data::TxnBuffer::write_double", XS_Data__TxnBuffer_write_double);
        newXS_deffile("Data::TxnBuffer::read_double", XS_Data__TxnBuffer_read_double);
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

